// TestMessageHandlerStream.cpp 
//

#include "stdafx.h"
#include "MessageHandlerStream.h"
#include <iostream>

//////////////////////////////////////////////////////////////////////////
namespace // anonymous namespace
{
	class CShowOnCout
		: public CMessageHandlerStream<>
	{
	public:

		virtual void OnNewMessage( const string_type & strNewMessage)
		{
			std::cout 
				<< "----------------------------"
				<< std::endl 
				<< strNewMessage
				<< "----------------------------"
				<< std::endl;
		}

	};


}; // anonymous namespace
//////////////////////////////////////////////////////////////////////////



void TestMessageHandlerStream()
{
	CShowOnCout show_cout;
	show_cout << "this is ";
	show_cout << "a ";
	show_cout << "unique";
	show_cout << " message";
	show_cout << std::endl;

	show_cout 
		<< "this is" << " a" << "nother" 
		<< ' ' << "unique message" << std::endl;
	show_cout 
		<< "You are number " << 1L << ", he is " 
		<< 's' << 'e' << "cond" << std::endl;

	show_cout << "test" << " me" << ",please!" << std::endl;

}

