/////////////////////////////////////////////////////////////////////
// Code accompanying "Embedded Angle" column in CUJ
// Copyright (c) 2002 Miro Samek 
/////////////////////////////////////////////////////////////////////
#ifndef instrument1_h
#define instrument1_h

#include <string.h> // for memcpy()

typedef char Note;

class Instrument {
public:
   virtual void playNote(Note key) = 0;
};

class GenericInstrument : public Instrument {
   char buf[40]; // maximum size of an Instrument
public:
   virtual void playNote(Note key) {
      this->playNote(key); // enforce late binding
   }
   /*
   GenericInstrument &operator=(GenericInstrument const &x) {
      if (&x != this) memcpy(this, &x, sizeof(*this));
      return *this;
   }
   */
};

class Configuration {
public: 
   //...
   GenericInstrument i; 
   //...
};

#endif // instrument1_h
